<?php
include_once 'api4marketing.php';

function iscriviNewsletter($emailAddress) {
	$apiUsername = variable_get ( 'fourdemConfig_username' );
	$apiPassword = variable_get ( 'fourdemConfig_password' );
	$apiURL = variable_get ( 'fourdemConfig_url' );
	$apiDestinationList = variable_get('fourdemConfig_newsletter_listID', -1); 
	$apiConnector = new api4marketing ( $apiURL, $apiUsername, $apiPassword );
	
	if ($apiConnector->getStatus () == false || $apiDestinationList == -1) {
		drupal_set_message ( t ( 'Unable to connect to 4Dem console' ), 'error' );
		return null;
	} else {
		$apiResult = $apiConnector->subscribe ( $apiDestinationList, $emailAddress );
		return $apiConnector->getResponse ();
	}
	
}


function recuperaArrayListe() {
	$apiUsername = variable_get ( 'fourdemConfig_username' );
	$apiPassword = variable_get ( 'fourdemConfig_password' );
	$apiURL = variable_get ( 'fourdemConfig_url' );
	$apiConnector = new api4marketing ( $apiURL, $apiUsername, $apiPassword );
	
	$apiResult = array(); //Array di ritorno
	
	$apiResult[-1] = t("-- Select a list --");
	if ($apiConnector->getStatus () != false) {
		$apiLists = $apiConnector->getLists ();
		foreach ( $apiLists as $singleList ) {
		$apiResult[$singleList->ListID] = $singleList->Name;
		}
	}
	
	return $apiResult;
}

/**
 * Implementation of hook_user_presave Drupal 7 internal function.
 * Every time a user is saved this code is executed: if the user is not new (unverified email) check if
 * email address is subscribed. If not insert on console, if yes check if user has updated his email address.
 * @param array $edit
 * @param object $account
 * @param unknown $category
 * @return NULL
 */
function fourdemnews_user_presave($edit, $account, $category){
	
	if ((! $account->is_new) && (variable_get ( 'fourdemConfig_Checkbox_AutoSynch', 0 )) ) {
		$apiUsername = variable_get ( 'fourdemConfig_username' );
		$apiPassword = variable_get ( 'fourdemConfig_password' );
		$apiURL = variable_get ( 'fourdemConfig_url' );
		$apiDestinationList = variable_get ( 'fourdemConfig_registered_listID', - 1 );
		$apiConnector = new api4marketing ( $apiURL, $apiUsername, $apiPassword );
		
		if ($apiConnector->getStatus () == false || $apiDestinationList == - 1) {
			drupal_set_message ( t ( 'Unable to connect to 4Dem console' ), 'error' );
			return null;
		} else {
			$apiUserId = $apiConnector->getSubscriber($apiDestinationList, $account->mail);
			if (!isset($apiUserId)){
				$apiResult = $apiConnector->subscribe ( $apiDestinationList, $edit['mail'] );
			} else{				
				if($edit['mail'] != $account->mail ) {
					$apiResult = $apiConnector->updSubscriber($apiUserId->SubscriberID, $apiDestinationList, $edit['mail']);
				}
			}
		}
	}
}
	
	// Synch local user repository with 4Dem remote console.
function sincronizzaUtenti($form, &$form_state) {
	$apiUsername = variable_get ( 'fourdemConfig_username' );
	$apiPassword = variable_get ( 'fourdemConfig_password' );
	$apiURL = variable_get ( 'fourdemConfig_url' );
	$apiDestinationList = variable_get ( 'fourdemConfig_registered_listID', - 1 );
	$apiConnector = new api4marketing ( $apiURL, $apiUsername, $apiPassword );
	
	if ($apiConnector->getStatus () == false || $apiDestinationList == - 1) {
		drupal_set_message ( t ( 'Unable to connect to 4Dem console' ), 'error' );
		return null;
	} else {
		$users = entity_load ( 'user' );
		foreach ( $users as $user_id => $user ) {
			$apiResult = $apiConnector->subscribe ( $apiDestinationList, $user->mail );
		}
	}
}

?>